using HarmonyLib;
using System.Collections;
using System.Reflection;
using UnityEngine;
using UnityEngine.Networking;
using System.Collections.Generic;
using System;


namespace Jerma985Rats {
    public class Jerma985Rats : Mod
    { 
        AssetBundle asset;
        public static GameObject RatObject;
        public IEnumerator Start()
        {
            var request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("rat.assets"));
            yield return request;
            asset = request.assetBundle;
            RatObject = asset.LoadAsset<GameObject>("ratPrefab");

            Debug.Log("Mod Jerma985_Rats has been loaded!");
        }

        public void OnModUnload()
        {
            asset.Unload(true);
            Debug.Log("Mod Jerma985_Rats has been unloaded!");
        }

        public static List<SkinnedMeshRenderer> GetRatSkins()
        {
            List<SkinnedMeshRenderer> result = new List<SkinnedMeshRenderer>();
            foreach (SkinnedMeshRenderer s in FindObjectsOfType<SkinnedMeshRenderer>())
                if (s.name.Contains("Rat"))
                    result.Add(s);
            return result;
        }
        
        public void Update()
        {
            foreach (SkinnedMeshRenderer s in GetRatSkins())
            {
                s.enabled = false;
                Transform parent = s.transform.parent.parent;
                if (!parent.Find("rat"))
                {
                    GameObject Rat = Instantiate(RatObject, parent.position, parent.rotation, parent);
                    Rat.name = "rat";
                    Rat.transform.Rotate(0.0f, 90.0f, 0.0f);
                    Rat.transform.localScale = new Vector3(0.2f, 0.2f, 0.2f);
                }
            }
        }
    }
}